﻿using Phidget22;
using System;
using System.Windows.Forms;
namespace MotorPositionController_Example.Resources {
	public partial class SettingsForm : Form {
		int currentState = 0; //0 = save settings, 1 = revert to saved, 2 = revert to default
		DeviceID motorID;
		public SettingsForm(Form owner) {
			InitializeComponent();
			this.Owner = owner;
			IntPtr dummy = this.Handle; //Force the form to load before it's shown so we can call invoke on it.
		}

		private void SettingsForm_FormClosing(object sender, FormClosingEventArgs e) {
			if (e.CloseReason == CloseReason.UserClosing) {
				this.Hide();
				e.Cancel = true;
			}
			removeAdded();
		}

		public void ShowSettingsBox(int state, DeviceID deviceID) {
			motorID = deviceID;
			currentState = state;
			for (int i = 0; i < settingsList.Items.Count; i++)
				settingsList.SetItemChecked(i, false);
			if (motorID == DeviceID.PN_DCC1000) {
				settingsList.Items.Add("Current Limit");
				settingsList.Items.Add("Current Regulator Gain");
				settingsList.Items.Add("Encoder IO Mode");
			} else if (motorID == DeviceID.PN_DCC1001) {
				settingsList.Items.Add("Current Limit");
			} else if (motorID == DeviceID.PN_DCC1100) {
				settingsList.Items.Add("Stall Velocity");
			}

			this.Show();
			if (state == 0) {
				enterButton.Text = "Save Settings";
			} else if (state == 1) {
				enterButton.Text = "Revert to Saved Settings";
			} else if (state == 2) {
				enterButton.Text = "Revert to Motor Defaults";
			}
		}

		private void enterButton_Click(object sender, EventArgs e) {
			Form1 owner = (Form1)this.Owner;
			owner.saveOrResetSettings(settingsList.CheckedItems, currentState);
			removeAdded();
		}
		private void selectAll_Click(object sender, EventArgs e) {
			for (int i = 0; i < settingsList.Items.Count; i++)
				settingsList.SetItemChecked(i, true);
		}
		private void deselectAll_Click(object sender, EventArgs e) {
			for (int i = 0; i < settingsList.Items.Count; i++)
				settingsList.SetItemChecked(i, false);
		}

		void removeAdded() {
			//remove anything we added to the settingslist
			if (motorID == DeviceID.PN_DCC1000) {
				settingsList.Items.Remove("Current Limit");
				settingsList.Items.Remove("Current Regulator Gain");
				settingsList.Items.Remove("Encoder IO Mode");
			} else if (motorID == DeviceID.PN_DCC1001) {
				settingsList.Items.Remove("Current Limit");
			} else if (motorID == DeviceID.PN_DCC1100) {
				settingsList.Items.Remove("Stall Velocity");
			}
		}

	}
}
